Package org.apache.sis.referencing.operation.projection

# Class TransverseMercator

Object
FormattableObject
AbstractMathTransform
AbstractMathTransform2D
NormalizedProjection
TransverseMercator

All Implemented Interfaces:
  `Serializable`, `Parameterized`, `LenientComparable`, `MathTransform`, `MathTransform2D`

public class TransverseMercator extends NormalizedProjection
Transverse Mercator projection (EPSG codes 9807). This class implements the "JHS formulas" reproduced in IOGP Publication 373-7-2 – Geomatics Guidance Note number 7, part 2 – April 2015.

## Description

This is a cylindrical projection, in which the cylinder has been rotated 90°. Instead of being tangent to the equator (or to an other standard latitude), it is tangent to a central meridian. Deformation are more important as we are going further from the central meridian. The Transverse Mercator projection is appropriate for region which have a greater extent north-south than east-west.

There are a number of versions of the Transverse Mercator projection including the Universal (UTM) and Modified (MTM) Transverses Mercator projections. In these cases the earth is divided into zones. For the UTM the zones are 6 degrees wide, numbered from 1 to 60 proceeding east from 180 degrees longitude, and between latitude 84 degrees North and 80 degrees South. The central meridian is taken as the center of the zone and the latitude of origin is the equator. A scale factor of 0.9996 and false easting of 500000 metres is used for all zones and a false northing of 10000000 metres is used for zones in the southern hemisphere.

## Domain of validity

The difference between longitude values λ and the central meridian λ₀ should be less than 60°. Differences larger than 90° of longitude cause a `ProjectionException` to be thrown. Differences between 60° and 90° are not rejected by Apache SIS but should be avoided. See the projection method for more information.

Since:
  0.6
See Also:
  - `Mercator`
  - `ObliqueMercator`
  - Serialized Form

Defined in the `sis-referencing` module

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class NormalizedProjection

  `NormalizedProjection​.ParameterRole`

- ## Field Summary

  ### Fields inherited from class NormalizedProjection

  `eccentricity, eccentricitySquared`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `TransverseMercator(OperationMethod method, Parameters parameters)`
  Creates a Transverse Mercator projection from the given parameters.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `MathTransform`
  `createMapProjection(MathTransformFactory factory)`
  Returns the sequence of normalization → `this` → denormalization transforms as a whole.
  `protected void`
  `inverseTransform(double[] srcPts, int srcOff, double[] dstPts, int dstOff)`
  Transforms the specified (η, ξ) coordinates and stores the result in `dstPts` (angles in radians).
  `Matrix`
  `transform(double[] srcPts, int srcOff, double[] dstPts, int dstOff, boolean derivate)`
  Converts the specified (λ,φ) coordinate (units in radians) and stores the result in `dstPts`.

  ### Methods inherited from class NormalizedProjection

  `computeHashCode, equals, getContextualParameters, getParameterDescriptors, getParameterValues, inverse, tryConcatenate`

  ### Methods inherited from class AbstractMathTransform2D

  `createTransformedShape, derivative, getSourceDimensions, getTargetDimensions, transform`

  ### Methods inherited from class AbstractMathTransform

  `derivative, equals, formatTo, hashCode, isIdentity, transform, transform, transform, transform, transform`

  ### Methods inherited from class FormattableObject

  `print, toString, toString, toWKT`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

  ### Methods inherited from interface MathTransform

  `derivative, isIdentity, toWKT, transform, transform, transform, transform, transform`

- ## Constructor Details

  - ### TransverseMercator

    public TransverseMercator(OperationMethod method, Parameters parameters)
    Creates a Transverse Mercator projection from the given parameters. The `method` argument can be the description of one of the following:
    - "Transverse Mercator".
    - "Transverse Mercator (South Orientated)".
    Parameters:
      `method` - description of the projection parameters.
      `parameters` - the parameter values of the projection to create.

- ## Method Details

  - ### createMapProjection

    public MathTransform createMapProjection(MathTransformFactory factory) throws FactoryException
    Returns the sequence of normalization → `this` → denormalization transforms as a whole. The transform returned by this method expects (longitude, latitude) coordinates in degrees and returns (x,y) coordinates in metres.

    The non-linear part of the returned transform will be `this` transform, except if the ellipsoid is spherical. In the later case, `this` transform will be replaced by a simplified implementation.

    Overrides:
      `createMapProjection` in class `NormalizedProjection`
    Parameters:
      `factory` - the factory to use for creating the transform.
    Returns:
      the map projection from (λ,φ) to (x,y) coordinates.
    Throws:
      `FactoryException` - if an error occurred while creating a transform.
    See Also:
      - `ContextualParameters​.completeTransform(MathTransformFactory, MathTransform)`

  - ### transform

    public Matrix transform(double[] srcPts, int srcOff, double[] dstPts, int dstOff, boolean derivate) throws ProjectionException
    Converts the specified (λ,φ) coordinate (units in radians) and stores the result in `dstPts`. In addition, opportunistically computes the projection derivative if `derivate` is `true`.

    #### Accuracy and domain of validity

    Projection errors depend on the difference ∆λ between longitude λ and the central meridian λ₀. All Universal Transverse Mercator (UTM) projections aim for ∆λ ≤ 3°, but this implementation can nevertheless handle larger values. Results have been compared with values provided by Karney, C.F.F. (2009). Test data for the transverse Mercator projection [Data set]. Zenodo. On the WGS84 ellipsoid we observed the following errors compared to Karney's data:
    - Errors less than 1 centimetre for ∆λ < 60° at all latitudes.
    - At latitudes far enough from equator (|φ| ≥ 20°), the domain can be extended up to ∆λ < (1 − ℯ)⋅90° (≈ 82.63627282416406551° on WGS84) with errors less than 70 centimetres.

    ##### Case of 82.6…° < ∆λ ≤ 90°

    Karney (2009) uses an “extended” domain of transverse Mercator projection for ∆λ ≥ (1 − ℯ)⋅90°, but Apache SIS does not support such extension. Consequently ∆λ values between (1 − ℯ)⋅90° and 90° should be considered invalid but are not rejected by Apache SIS. Note that those invalid values are consistent with the inverse projection (i.e. applying a projection followed by an inverse projection gives approximately the original values).
    Rational: those coordinates are accepted despite the low accuracy of projection results because they are sometime needed for expressing bounding boxes. A bounding box may have corners located in invalid projection area even if all features inside the box have valid coordinates. For "contains" and "intersects" tests between envelopes, we do not need accurate coordinates; a monotonic behavior of x = f(λ) can be sufficient.

    ##### Case of ∆λ > 90°

    Longitude values at a distance greater than 90° from the central meridian are rejected. A `ProjectionException` is thrown in that case. This limit exists because the Transverse Mercator projection is conceptually a Mercator projection rotated by 90°. Consequently x values tend toward infinity for ∆λ close to ±90°
    Specified by:
      `transform` in class `NormalizedProjection`
    Parameters:
      `srcPts` - the array containing the source point coordinate, as (longitude, latitude) angles in radians.
      `srcOff` - the offset of the single coordinate to be converted in the source array.
      `dstPts` - the array into which the converted coordinate is returned (may be the same than `srcPts`). Coordinates will be expressed in a dimensionless unit, as a linear distance on a unit sphere or ellipse.
      `dstOff` - the offset of the location of the converted coordinate that is stored in the destination array.
      `derivate` - `true` for computing the derivative, or `false` if not needed.
    Returns:
      the matrix of the projection derivative at the given source position, or `null` if the `derivate` argument is `false`.
    Throws:
      `ProjectionException` - if the coordinate can not be converted.
    See Also:
      - `AbstractMathTransform​.derivative(DirectPosition)`
      - `AbstractMathTransform​.transform(DirectPosition, DirectPosition)`
      - `MathTransforms​.derivativeAndTransform(MathTransform, double[], int, double[], int)`

  - ### inverseTransform

    protected void inverseTransform(double[] srcPts, int srcOff, double[] dstPts, int dstOff) throws ProjectionException
    Transforms the specified (η, ξ) coordinates and stores the result in `dstPts` (angles in radians).
    Specified by:
      `inverseTransform` in class `NormalizedProjection`
    Parameters:
      `srcPts` - the array containing the source point coordinate, as linear distance on a unit sphere or ellipse.
      `srcOff` - the offset of the point to be converted in the source array.
      `dstPts` - the array into which the converted point coordinate is returned (may be the same than `srcPts`). Coordinates will be (longitude, latitude) angles in radians.
      `dstOff` - the offset of the location of the converted point that is stored in the destination array.
    Throws:
      `ProjectionException` - if the point can not be converted.